package com.xinelu.manage.service.department;

import com.xinelu.common.core.domain.AjaxResult;
import com.xinelu.manage.domain.department.Department;
import com.xinelu.manage.dto.department.DepartmentDTO;
import com.xinelu.manage.vo.department.DepartmentBaseVo;
import com.xinelu.manage.vo.department.DepartmentListVO;
import java.util.List;


/**
 * 科室信息Service接口
 *
 * @author xinelu
 * @date 2024-02-26
 */
public interface IDepartmentService {
    /**
     * 查询科室信息
     *
     * @param id 科室信息主键
     * @return 科室信息
     */
    DepartmentListVO selectDepartmentById(Long id);

    /**
     * 查询科室信息列表
     *
     * @param department 科室信息
     * @return 科室信息集合
     */
    List<Department> selectDepartmentList(Department department);

    /**
     * 查询科室信息列表 问卷使用
     *
     * @return 科室信息集合
     */
    AjaxResult selectUserDepartment();

    /**
     * 查询科室或病区信息列表 不分页
     *
     * @param department 科室信息
     * @return 科室信息集合
     */
    AjaxResult selectDepartmentByAgencyIdList(Department department);

    /**
     * 新增科室信息
     *
     * @param department 科室信息
     * @return 结果
     */
    AjaxResult insertDepartment(Department department);

    /**
     * 修改科室信息
     *
     * @param department 科室信息
     * @return 结果
     */
    AjaxResult updateDepartment(Department department);

    /**
     * 批量删除科室信息
     *
     * @param ids 需要删除的科室信息主键集合
     * @return 结果
     */
    AjaxResult deleteDepartmentByIds(Long[] ids);

    /**
     * 删除科室信息信息
     *
     * @param id 科室信息主键
     * @return 结果
     */
    int deleteDepartmentById(Long id);

    /**
     * 查询科室信息列表及包含话术数量
     *
     * @param departmentDto
     * @return
     */
    DepartmentBaseVo selectDepartmentListScriptNum(DepartmentDTO departmentDto);

    /**
     * 查询科室信息列表及包含手术数量
     *
     * @param departmentDto
     * @return
     */
    DepartmentBaseVo selectDepartmentListOperationNum(DepartmentDTO departmentDto);

    /**
     * 查询科室信息列表及包含微信库数量
     *
     * @param departmentDto
     * @return
     */
    DepartmentBaseVo selectDepartmentListWechatTemplateNum(DepartmentDTO departmentDto);

    /**
     * 查询科室信息列表及包含短信库数量
     *
     * @param departmentDto
     * @return
     */
    DepartmentBaseVo selectDepartmentListMessageNum(DepartmentDTO departmentDto);

    /**
     * 科室信息导入
     *
     * @param departmentList 科室信息
     * @return int
     **/
    AjaxResult insertDepartmentList(List<Department> departmentList);

    /**
     * 查询科室信息列表及包含服务包数量
     *
     * @param departmentDto
     * @return
     */
    DepartmentBaseVo selectListServicePackageNum(DepartmentDTO departmentDto);
}
